#!/bin/sh
#
# new_ca.sh
# dient zum Anlegen einer neuen CA
# CATOP mu unbedingt entsprechend gesetzt werden!
# nderungen in diesem Script mssen auch in ssleay.cnf bercksichtigt werden!
#
# Aenderungen des Zertifikats-Dowload-Verzeichnisses (in der Variable 
# CACERT_DER) muessen auch in send-cert.cgi vorgenommen werden!
#
SSLBIN=/usr/local/ssl/bin
REQ="$SSLBIN/ssleay req"
X509="$SSLBIN/ssleay x509"

CANAME=$1
CATOP=/usr/local/CA
CADIR=${CATOP}/${CANAME}
CAKEY=${CADIR}/cakey.pem
CACERT=${CADIR}/cacert.pem
CACERT_DER=${CATOP}/download/${CANAME}.der
CONFIG=${CATOP}/ssleayRq.cnf


if  [ $# -ne 1 ]
then
    echo "Benutzung: $0 Kurzname_der_CA"
    exit
fi

# Bentigte Verzeichnisse und Dateien erzeugen
mkdir ${CADIR} 
mkdir ${CADIR}/archive
echo "01" > ${CADIR}/serial
touch ${CADIR}/index.txt

# Zertifikat fr die CA erstellen mit 1024-Bit Schlssel, gltig fr 3 Jahre
$REQ -config $CONFIG -new -x509 -keyout $CAKEY -out $CACERT -days 1095 
$X509 -in $CACERT -outform der -out $CACERT_DER

echo "Ein Download des zertifikats ist moeglich ueber"
echo "http://der.server.de/cgi-pfad/send-cert.cgi/$CACERT_DER"
