/*	POSTIT -- Get the FORM parameters.
 *	Kurt J. Lanza (kjl@infor.com)
 *	21 March 1994
 *
 *	Derived from the "post-query" program by robm@ncsa.uiuc.edu --
 *		major credit to him.
 *
 *	This variant reads the "name=value" pairs from the POST method
 *		and writes lines of the form "name value". Thus this
 *		command may be used inside a Bourne shell "while" loop.
 *		Its intent is to provide arguments to the cgi-script.
 *	Why not just put them in the environment? I don't know -- just a
 *		guess that that approach might not be quite so general.
 */


#include <stdio.h>
#include <stdlib.h>

#define MAX_ENTRIES 10000

typedef struct {
    char *name;
    char *val;
} entry;

char *makeword(char *line, char stop);
char *fmakeword(FILE *f, char stop, int *len);
char x2c(char *what);
void unescape_url(char *url);
void plustospace(char *str);


int main(int argc, char *argv[]) {
  entry entries[MAX_ENTRIES];
  register int x,m=0;
  int cl;
  char sep=' ';
  char ignore='\0';
  char *s;

  argc--; argv++;
  while (argc>0) {
    if (strcmp(*argv,"-s") == 0) {
      if (argc>0) {
	sep=**(++argv);
	argc--;
      }
      else 
	exit(1);
    }
    else if (strcmp(*argv,"-i") == 0) {
      if (argc>0) {
	s=*(++argv);
	switch (strlen(s)) {
	case 1: 
	  ignore=*s; break;
	case 4:
	  if (s[0] == '0' && s[1] == 'x')
	    ignore=x2c(&s[2]);
	}
	argc--;
      }
      else 
	exit(1);
    }
    argc--; argv++;
  }
  if(strcmp(getenv("REQUEST_METHOD"),"POST")) exit(1);
  if(strcmp(getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded")) exit(1);
  cl = atoi(getenv("CONTENT_LENGTH"));

  for(x=0;cl>0 && (!feof(stdin));x++) {
    m=x;
    s=fmakeword(stdin,'&',&cl);
    plustospace(s);
    unescape_url(s);
    {
      register int x,y;

      for(x=0,y=0;s[y];++x,++y) {
        if((s[x] = s[y]) == ignore)
	  x--;
      }
      s[x] = '\0';
    }
    entries[x].val=s;
    entries[x].name = makeword(entries[x].val,'=');
  }
  
  for(x=0; x <= m; x++)
    printf("%s%c%s\n",entries[x].name, sep, entries[x].val);
  exit(0);
}
